diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
index 0614ba8e4..2160d52ec 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJar.java
@@ -60,7 +60,7 @@ public class BlockLogicJar extends BlockLogic implements ISupportable {
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (player.getHeldItem() == null) {
             if (world.getBlockData(tilePos) == 0) {
-                world.setBlockIdNotify(tilePos, 0);
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
                 if (!world.isClientSide) {
                     world.dropItem(tilePos, new ItemStack(this.itemSupplier.get(), 1, 0));
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
index 05eee30f7..5e9e63706 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicJarButterfly.java
@@ -65,7 +65,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
 
     @Override
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        world.setBlockIdRaw(tilePos, 0);
+        world.setBlockTypeRaw(tilePos, Blocks.AIR);
         world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
         if (!world.isClientSide) {
             world.dropItem(tilePos, new ItemStack(this.itemSupplier.get(), 1, 0));
@@ -78,7 +78,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         TilePos queryPos = new TilePos();
-        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.CAN_HANG_OFF))) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockType(tilePos.up(queryPos)), BlockTags.CAN_HANG_OFF))) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
             return;
         }
@@ -86,7 +86,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
             world.setBlockDataNotify(tilePos, 0);
             return;
         }
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(queryPos)).hasTag(BlockTags.CAN_HANG_OFF)) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
         } else {
             world.setBlockDataNotify(tilePos, 0);
@@ -95,7 +95,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
@@ -103,10 +103,10 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -122,7 +122,7 @@ public class BlockLogicJarButterfly extends BlockLogic implements ISupportable {
     public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         if ((meta & MASK_HANGING) != 0) {
-            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF);
+            return isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF);
         }
 
         return isSupported(world, tilePos, Side.BOTTOM);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
index 60da91151..a6371b971 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLadder.java
@@ -55,10 +55,10 @@ public class BlockLogicLadder extends BlockLogic implements ISupportable {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!canExistAt(world, tilePos, world.getBlockData(tilePos))) {
-            dropWithCause(world, EnumDropCause.WORLD, tilePos, id, null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            dropWithCause(world, EnumDropCause.WORLD, tilePos, block.id(), null, null);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
index f4ff9f0f6..365d71345 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLamp.java
@@ -28,11 +28,11 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         if (this.isInverted) {
             if (this.isActive && (world.hasDirectSignal(tilePos) || world.hasNeighborSignal(tilePos))) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE, world.getBlockData(tilePos));
             }
         } else {
             if (this.isActive && !(world.hasDirectSignal(tilePos) || world.hasNeighborSignal(tilePos))) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_IDLE, world.getBlockData(tilePos));
             }
         }
     }
@@ -47,34 +47,34 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
 
         if (this.isInverted) {
             if (hasSignal && this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE, world.getBlockData(tilePos));
             } else if (!hasSignal && !this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE, world.getBlockData(tilePos));
             }
         } else {
             if (hasSignal && !this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_ACTIVE.id(), world.getBlockId(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_ACTIVE, world.getBlockData(tilePos));
             } else if (!hasSignal && this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_IDLE, world.getBlockData(tilePos));
             }
         }
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final boolean hasSignal = world.hasDirectSignal(tilePos) || world.hasNeighborSignal(tilePos);
 
         if (this.isInverted) {
             if (hasSignal && this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE, world.getBlockData(tilePos));
             } else if (!hasSignal && !this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE, world.getBlockData(tilePos));
             }
         } else {
             if (hasSignal && !this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_ACTIVE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_ACTIVE, world.getBlockData(tilePos));
             } else if (!hasSignal && this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_IDLE, world.getBlockData(tilePos));
             }
         }
     }
@@ -96,15 +96,15 @@ public class BlockLogicLamp extends BlockLogic implements IPainted {
     public void invertLamp(final @NotNull World world, final @NotNull TilePosc tilePos) {
         if (this.isInverted) {
             if (this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_IDLE, world.getBlockData(tilePos));
             } else {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_ACTIVE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_ACTIVE, world.getBlockData(tilePos));
             }
         } else {
             if (this.isActive) {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_IDLE, world.getBlockData(tilePos));
             } else {
-                world.setBlockIdDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE.id(), world.getBlockData(tilePos));
+                world.setBlockTypeDataNotify(tilePos, Blocks.LAMP_INVERTED_ACTIVE, world.getBlockData(tilePos));
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
index f049d9d2f..c3de59516 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLanternFirefly.java
@@ -71,7 +71,7 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
 
     @Override
     public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        world.setBlockIdRaw(tilePos, 0);
+        world.setBlockTypeRaw(tilePos, Blocks.AIR);
         world.playSoundAtEntity(player, player, "item.pickup", 1f, 1f);
         if (!world.isClientSide) {
             world.dropItem(tilePos, new ItemStack(this.itemSupplier.get(), 1, 0));
@@ -83,7 +83,7 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
 
     @Override
     public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
-        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF))) {
+        if ((side == Side.BOTTOM || (side != Side.TOP && yHit >= 0.5d)) && (isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF))) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
             return;
         }
@@ -91,7 +91,7 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
             world.setBlockDataNotify(tilePos, 0);
             return;
         }
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF)) {
             world.setBlockDataNotify(tilePos, MASK_HANGING);
         } else {
             world.setBlockDataNotify(tilePos, 0);
@@ -100,7 +100,7 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
-        if (isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF)) {
+        if (isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF)) {
             return true;
         }
 
@@ -108,10 +108,10 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -127,7 +127,7 @@ public class BlockLogicLanternFirefly extends BlockLogic implements ISupportable
     public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         if ((meta & MASK_HANGING) != 0) {
-            return isSupported(world, tilePos, Side.TOP) || Blocks.hasTag(world.getBlockId(tilePos.up(new TilePos())), BlockTags.CAN_HANG_OFF);
+            return isSupported(world, tilePos, Side.TOP) || world.getBlockType(tilePos.up(new TilePos())).hasTag(BlockTags.CAN_HANG_OFF);
         }
 
         return isSupported(world, tilePos, Side.BOTTOM);
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
index aa6cc9852..06b608fd0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerAsh.java
@@ -28,7 +28,7 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
             Direction dir = Direction.horizontalDirections[i];
             TilePos dirPos = tilePos.add(dir, new TilePos());
-            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockId(dirPos) == this.block.id() && world.getBlockData(dirPos) >= myMetadata))) return;
+            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockType(dirPos) == this.block && world.getBlockData(dirPos) >= myMetadata))) return;
         }
 
         world.setBlockData(tilePos, myMetadata + 1);
@@ -38,7 +38,7 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     @Override
 	public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos down = tilePos.down(new TilePos());
-        Block<?> b = world.getBlock(down);
+        Block<?> b = world.getBlockType(down);
         if(b == null || !b.isSolidRender()) {
         	return false;
         } else {
@@ -48,16 +48,16 @@ public class BlockLogicLayerAsh extends BlockLogicLayerBase
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+    public @NotNull ItemStack @Nullable [] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return switch (dropCause) {
             case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, data + 1)};
             case PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
index 33956bcfd..52b510ea7 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerLeaves.java
@@ -38,7 +38,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
             TilePos p = tilePos.add(Direction.horizontalDirections[i], new TilePos());
 
-            if (!((world.isBlockOpaqueCube(p)) || (world.getBlockId(p) == this.block.id() && world.getBlockData(p) >= myMetadata))) {
+            if (!((world.isBlockOpaqueCube(p)) || (world.getBlockType(p) == this.block && world.getBlockData(p) >= myMetadata))) {
                 return;
             }
         }
@@ -50,7 +50,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos down = tilePos.down(new TilePos());
-        Block<?> b = world.getBlock(down);
+        Block<?> b = world.getBlockType(down);
         if (b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
             return false;
         } else {
@@ -60,11 +60,11 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -87,7 +87,7 @@ public class BlockLogicLayerLeaves extends BlockLogicLayerBase {
                     if (metadata > 0) {
                         world.setBlockData(tilePos, metadata - 1);
                     } else {
-                        world.setBlockIdNotify(tilePos, 0);
+                        world.setBlockTypeNotify(tilePos, Blocks.AIR);
                     }
                 }
             }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index 68834459e..61f712082 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -34,7 +34,7 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
         for (int i = 0; i < Direction.horizontalDirections.length; i++) {
             Direction dir = Direction.horizontalDirections[i];
             TilePos dirPos = tilePos.add(dir, new TilePos());
-            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockId(dirPos) == this.block.id() && world.getBlockData(dirPos) >= myMetadata)))
+            if (!((world.isBlockOpaqueCube(dirPos)) || (world.getBlockType(dirPos) == this.block && world.getBlockData(dirPos) >= myMetadata)))
                 return;
         }
 
@@ -45,8 +45,8 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         TilePos down = tilePos.down(new TilePos());
-        Block<?> b = world.getBlock(down);
-        if (b == null || (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase))) {
+        Block<?> b = world.getBlockType(down);
+        if (!b.isSolidRender() && !(b.getLogic() instanceof BlockLogicLeavesBase)) {
             return false;
         } else {
             Material material = world.getBlockMaterial(down);
@@ -61,11 +61,11 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
     }
 
     @Override
-    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         // Remove if no longer valid
         if (!canPlaceAt(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -83,11 +83,11 @@ public class BlockLogicLayerSnow extends BlockLogicLayerBase {
     public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         if (world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
         if (!world.getBlockBiome(tilePos).hasSurfaceSnow() && world.getSeasonManager().getCurrentSeason() != null && world.getSeasonManager().getCurrentSeason().letWeatherCleanUpSnow) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
index 184376156..cb11548b1 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesBase.java
@@ -70,7 +70,7 @@ public class BlockLogicLeavesBase extends BlockLogic {
                 for (int dy = -radius; dy <= radius; dy++) {
                     for (int dz = -radius; dz <= radius; dz++) {
                         p.set(tilePos.x() + dx, tilePos.y() + dy, tilePos.z() + dz);
-                        Block<?> block = world.getBlock(p);
+                        Block<?> block = world.getBlockType(p);
                         if (block != null && block.getLogic() instanceof BlockLogicLeavesBase) {
                             int meta = world.getBlockData(p);
                             if (!isPermanent(meta)) {
@@ -103,7 +103,7 @@ public class BlockLogicLeavesBase extends BlockLogic {
                 for (int xOffset = -radius; xOffset <= radius; xOffset++) {
                     for (int yOffset = -radius; yOffset <= radius; yOffset++) {
                         for (int zOffset = -radius; zOffset <= radius; zOffset++) {
-                            Block<?> block = world.getBlock(p.set(tilePos.x() + xOffset, tilePos.y() + yOffset, tilePos.z() + zOffset));
+                            Block<?> block = world.getBlockType(p.set(tilePos.x() + xOffset, tilePos.y() + yOffset, tilePos.z() + zOffset));
 
                             int i = (xOffset + halfLength) * xSpan + (yOffset + halfLength) * ySpan + (zOffset + halfLength);
                             if (block != null && block.getLogic() instanceof BlockLogicLog) {
@@ -165,7 +165,7 @@ public class BlockLogicLeavesBase extends BlockLogic {
 
     private void removeLeaves(@NotNull World world, @NotNull TilePosc tilePos) {
         dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-        world.setBlockIdNotify(tilePos, 0);
+        world.setBlockTypeNotify(tilePos, Blocks.AIR);
     }
 
     public static boolean isPermanent(int meta) {
@@ -204,7 +204,7 @@ public class BlockLogicLeavesBase extends BlockLogic {
 
     @Override
     public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        Block<?> bBlock = world.getBlock(thatPos);
+        Block<?> bBlock = world.getBlockType(thatPos);
 
         int thisMeta = world.getBlockData(thisPos) & ~MASK_DECAY_DATA;
         int otherMeta = world.getBlockData(thatPos) & ~MASK_DECAY_DATA;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
index 94dd51f61..39f7684d8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCacao.java
@@ -36,7 +36,7 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
         TilePos queryPos = new TilePos(tilePos);
         for (int x = tilePos.x() - 1; x < tilePos.x() + 1; x++) {
             for (int z = tilePos.z() - 1; z < tilePos.z() + 1; z++) {
-                if (world.getBlock(queryPos.set(x, tilePos.y(), z)) == null) {
+                if (world.getBlockType(queryPos.set(x, tilePos.y(), z)) == null) {
                     return true;
                 }
             }
@@ -83,7 +83,7 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
                 dropWithCause(world, EnumDropCause.WORLD, tilePos, meta, null, null);
             }
             world.setBlockDataNotify(tilePos, setGrowthRate(meta, 0));
-            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO.id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO, tickDelay());
             return true;
         }
         return false;
@@ -99,12 +99,12 @@ public class BlockLogicLeavesCacao extends BlockLogicLeavesBase implements IBone
                 if (canBeansGrow(world, tilePos)) {
                     if (growthRate < MAX_GROWTH_STATE) {
                         world.setBlockDataNotify(tilePos, setGrowthRate(meta, ++growthRate));
-                        world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO.id(), tickDelay());
+                        world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO, tickDelay());
                     }
                 }
             } else if (growthRate > 0) {
                 world.setBlockDataNotify(tilePos, setGrowthRate(meta, 0));
-                world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO.id(), tickDelay());
+                world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CACAO, tickDelay());
             }
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
index 447ec0dad..fcd2d4395 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLeavesCherryFlowering.java
@@ -58,7 +58,7 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
                 dropWithCause(world, EnumDropCause.WORLD, tilePos, meta, null, null);
             }
             world.setBlockDataNotify(tilePos, setGrowthRate(meta, 0));
-            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING, tickDelay());
             return true;
         }
         return false;
@@ -79,12 +79,12 @@ public class BlockLogicLeavesCherryFlowering extends BlockLogicLeavesCherry impl
             if (rand.nextInt(20) == 0) {
                 if ((growthRate) == 0) {
                     world.setBlockDataNotify(tilePos, setGrowthRate(meta, MAX_GROWTH_STATE));
-                    world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
+                    world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING, tickDelay());
                 }
             }
         } else if(growthRate > 0){
             world.setBlockDataNotify(tilePos, meta & MASK_DECAY_DATA);
-            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING.id(), tickDelay());
+            world.scheduleBlockUpdate(tilePos, Blocks.LEAVES_CHERRY_FLOWERING, tickDelay());
         }
     }
 
